---
title: glossary
---

abra-related words

- recipe - a git repository with files describing to abra how to assemble an application
- application - an instance of a recipe composed of one or more services and running as a docker stack
- service - a single docker container that is a part of a stack, configured in compose.yml and .env files
- deployment - the act of assembling a docker stack described by a recipe and application configuration


docker-related words:

- image - a template for creating containers, describing their file structure, installed binaries etc.
- container - an instance of an image, running processes that are isolated from the host system
- environment variables - variables passed from the shell to processes invoked by it. used for configuring services.
- .env file - a file describing the contents of environmental variables
- network - a virtual network created on the server machine used for communicating between services (containers). Any service can be plugged into more than one network, allowing for control over data sharing between them.
- secret - docker uses those for securely storing data such as passwords. They are stored encrypted on disk and mounted inside the containers as files that can be read that contain the secret.
- stack - one or more services (containers) running together to provide a functionality.
- volume - a directory that can be mounted inside a docker container to store data. Because containers are meant to be non-changeable and disposable, any data that is supposed to not be lost between updates or restarts is stored in volumes.


"mappings" between those concepts:

- abra app = docker stack
- abra recipe = set of docker images in `compose` format
- abra service = docker stack service
